<template>
  <div class="q-pa-md">
    <div>
      <h1>  Query EoX API by SW Release </h1>

      <div class="row">
        <div class="col-sm-3 col-12">
          <q-input outlined stack-label
                   v-model="swRelease"
                   color="indigo-8"
                   label="Software Release(s)"
                   hint="Up to 20 releases and OS type separated by semicolons.
                   Ex.: 15.5(3)M5,IOS;12.2,IOS" />
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <span >. </span>
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12">
          <q-input outlined stack-label
                   v-model="pageIndex"
                   color="indigo-8"
                   label="Page Index"
                   hint="Requested page (defaults to 1)" />
        </div>
      </div>
    </div>

    <div class="actions" align="right" style="max-width: 130px">
        <q-btn color="light-blue-4" @click="fetchData">
          <q-icon size="2em" name="youtube_searched_for" />
          <div>Search</div>
        </q-btn>
    </div>


    <div class="q-pa-md" v-show="EOXRecordTableData.length">
      <q-banner rounded dense class="bg-light-blue-4 text-white q-pa-md" >
        <b>EOXBySWRelease returned:  </b>{{PaginationResponseRecord.TotalRecords}} records & {{PaginationResponseRecord.LastIndex}} pages <br>
        <i>(Exhibiting page {{PaginationResponseRecord.PageIndex}} containing {{PaginationResponseRecord.PageRecords}} records)</i>.
        <template v-slot:action>
          <q-chip dense clickable @click="downloadFile(EOXFileName + '.json')" icon="save_alt">.json </q-chip>
          <q-chip dense clickable @click="downloadFile(EOXFileName + '.csv')" icon="save_alt">.csv</q-chip>
        </template>
      </q-banner>
      <div class="q-pa-md" >
        <q-table
          title="EOXBySWRelease Records"
          :columns="EoXRecordTableColumns"
          :data="EOXRecordTableData"
          :rows-per-page-options="[15]"
        />
      </div>
    </div>

    <div class="q-pa-md" v-show="EOXErrorsData.length">
      <q-banner rounded dense class="bg-red-2 text-black q-pa-md">
        <b>EOXBySWRelease returned Error Record(s):  </b><br><p v-html="EOXErrorsData"></p>
      </q-banner>
    </div>

  </div>
</template>

<script>
export default {
  data() {
    return {
      showEOXTable: false,
      swRelease: null,
      pageIndex: 1,
      PaginationResponseRecord: {
        TotalRecords: 0,
        LastIndex: 0,
        PageIndex: 0,
        PageRecords: 0
      },
      EOXRecord: null,
      EOXError: null,
      EOXRecordTableData: [],
      EoXRecordTableColumns: [
        {
          name: "EOLProductID",
          label: "EOLProductID",
          field: "EOLProductID",
          sortable: true
        },
        {
          name: "ProductIDDescription",
          label: "ProductIDDescription",
          field: "ProductIDDescription",
          sortable: true
        },
        {
          name: "EOXExternalAnnouncementDate",
          label: "EOXExternalAnnouncementDate",
          field: "EOXExternalAnnouncementDate",
          sortable: true
        },
        {
          name: "EndOfSaleDate",
          label: "EndOfSaleDate",
          field: "EndOfSaleDate",
          sortable: true
        },
        {
          name: "EndOfSWMaintenanceReleases",
          label: "EndOfSWMaintenanceReleases",
          field: "EndOfSWMaintenanceReleases",
          sortable: true
        },
        {
          name: "EndOfSecurityVulSupportDate",
          label:"EndOfSecurityVulSupportDate",
          field: "EndOfSecurityVulSupportDate",
          sortable: true
        },
        {
          name: "EndOfRoutineFailureAnalysisDate",
          label:"EndOfRoutineFailureAnalysisDate",
          field: "EndOfRoutineFailureAnalysisDate",
          sortable: true
        },
        {
          name:  "EndOfServiceContractRenewal",
          label: "EndOfServiceContractRenewal",
          field:  "EndOfServiceContractRenewal",
          sortable: true
        },
        {
          name:  "LastDateOfSupport",
          label: "LastDateOfSupport",
          field:  "LastDateOfSupport",
          sortable: true
        },
        {
          name:  "EndOfSvcAttachDate",
          label: "EndOfSvcAttachDate",
          field: "EndOfSvcAttachDate",
          sortable: true
        },
        {
          name:  "MigrationInformation",
          label: "MigrationInformation",
          field: "MigrationInformation",
          sortable: false
        },
        {
          name:  "MigrationOption",
          label: "MigrationOption",
          field:  "MigrationOption",
          sortable: false
        },
        {
          name: "MigrationProductId",
          label:"MigrationProductId",
          field:  "MigrationProductId",
          sortable: false
        },
        {
          name:  "MigrationProductName",
          label: "MigrationProductName",
          field:   "MigrationProductName",
          sortable: false
        }
      ],
      EOXFileName: '',
      EOXErrorsData: '',
    }
  },
  methods: {
    fetchData() {
      this.EOXRecord = null;
      this.EOXRecordTableData = [];
      this.EOXErrorsData = [];
      this.EOXFileName = '';
      this.$q.loading.show();
      const url = `EOXBySWReleaseString?pageIndex=${this.pageIndex}&release=${this.swRelease}`
      this.$axios.get(url)
        .then(response => {
          console.log(response)
          if ('EOXError' in response.data){
            this.EOXErrorsData = response.data.EOXError.ErrorID + ": " + response.data.EOXError.ErrorDescription
          }
          else{
            this.EOXFileName = response.data.FileName;
            if ('EOXRecord' in response.data){
              this.EOXRecord = response.data.EOXRecord;
              this.PaginationResponseRecord = response.data.PaginationResponseRecord;

              console.log(this.EOXRecord)
              let rec;
              for (rec in this.EOXRecord){
                if ('EOXError' in this.EOXRecord[rec]){
                  console.log('there is an error here')
                  this.EOXErrorsData = this.EOXErrorsData + this.EOXRecord[rec].EOXError.ErrorID + `:` +
                    this.EOXRecord[rec].EOXError.ErrorDescription + " For input -> " + this.EOXRecord[rec].EOXInputValue + "<br>"
                }
                else {
                  let data = {
                    EOLProductID:  this.EOXRecord[rec].EOLProductID,
                    ProductIDDescription: this.EOXRecord[rec].ProductIDDescription,
                    EOXExternalAnnouncementDate: this.EOXRecord[rec].EOXExternalAnnouncementDate.value,
                    EndOfSaleDate:	this.EOXRecord[rec].EndOfSaleDate.value,
                    EndOfSWMaintenanceReleases: this.EOXRecord[rec].EndOfSWMaintenanceReleases.value,
                    EndOfSecurityVulSupportDate: this.returnValueOrNothing(this.EOXRecord[rec], "EndOfSecurityVulSupportDate"),
                    EndOfRoutineFailureAnalysisDate: this.EOXRecord[rec].EndOfRoutineFailureAnalysisDate.value,
                    EndOfServiceContractRenewal: this.EOXRecord[rec].EndOfServiceContractRenewal.value,
                    LastDateOfSupport: this.EOXRecord[rec].LastDateOfSupport.value,
                    EndOfSvcAttachDate: this.EOXRecord[rec].EndOfSvcAttachDate.value,
                    MigrationInformation:	this.EOXRecord[rec].EOXMigrationDetails.MigrationInformation,
                    MigrationOption: this.EOXRecord[rec].EOXMigrationDetails.MigrationOption,
                    MigrationProductId:	this.EOXRecord[rec].EOXMigrationDetails.MigrationProductId,
                    MigrationProductName: this.EOXRecord[rec].EOXMigrationDetails.MigrationProductName
                  }
                  this.EOXRecordTableData.push(data)
                }
              }
            }
          }
        })
        .catch(() => this.notify('Ops, unexpected error. Please, try again later.', 'error'))
        .finally(() => this.$q.loading.hide())
    },
    notify(message, icon = 'check') {
      this.$q.notify({ icon, position: 'top', message })
    },
    downloadFile(fileName){
      this.$axios({
        method: 'get',
        url: `/download/${fileName}`,
        responseType: 'arraybuffer'
      })
        .then(response => {

          this.forceFileDownload(response, fileName)

        })
        .catch(() => console.log('error occured'))
    },
    forceFileDownload(response, fileName){
      const url = window.URL.createObjectURL(new Blob([response.data]))
      const link = document.createElement('a')
      link.href = url
      link.setAttribute('download', fileName) //or any other extension
      document.body.appendChild(link)
      link.click()
    },
    returnValueOrNothing(obj, key){
      if (key in obj){
        return obj[key].value
      }
      return ''
    }
  }
}
</script>

<style lang="stylus">
  h1
    font-size 1.5rem
    line-height 2rem

  h2
    font-size 0.9rem
    line-height 2rem

  .actions
    margin-top 20px

  .info
    background-color rgb(247, 232, 236)

  .q-chip--dense
    font-size 14px
</style>
